var arSeverity = new Array(1);
function initArSeverity() {
	arSeverity[1]=new Array(1);
	arSeverity[2]=new Array(1);
	arSeverity[3]=new Array(1);
	arSeverity[4]=new Array(1);
	
}
function urPopulateStats(xReview) {
  //dumpXML("Stats>>\n" + xReview);
  var content = '';
  var curNode;
  viewNode = document.getElementById("urTopStats");
  debugDump("Doing stats with " + xReview.nodeName + " " +  xReview.childNodes.length +   " "+ "\n");
 	// Compute Summary
	initArSeverity();
  var pages = xReview.getElementsByTagName("page");
  var keywords = xReview.getElementsByTagName("keyword");
	var heuristics = xReview.getElementsByTagName("heuristic");
  if(pages.length) content += (pages.length) + " Pages <br/>";
  if(keywords.length) content += (keywords.length) + " Keywords <br/>";
	
	if(heuristics.length) content += (heuristics.length) + " Heuristics <br/>";
	

  return content;
	//viewNode.innerHTML = content;
}

function urPopulateProblems(xReview) {
  var heuristics = xReview.getElementsByTagName("heuristic");
  var heuristicCount = new Object();
  var heuristicName = '';
	var severity;
	debugDump("Doing heurs with " +heuristics.length + "\n");
  for(var j=0;j<heuristics.length;j++) {
    heuristicName =heuristics.item(j).getAttribute("id");
		severity = heuristics.item(j).getAttribute("value");
		heuristics.item(j).setAttribute("offset", j);
		if(severity && severity < 1) {
	    if(heuristicCount[heuristicName]) {
	       heuristicCount[heuristicName]++;
	    } else {
	      heuristicCount[heuristicName]= 1;		
	    }
			severity = Math.abs(severity);
			arSeverity[severity][arSeverity[severity].length] = heuristics.item(j);
	  }
	}
  for(var k in heuristicCount) {
		dump(k + "\n");
    content += heuristicCount[k] + " " + k + "<br/>";
  }
	return content;
}


function urPopulateFocii(xReview) {
	content = '';
	pages = xReview.getElementsByTagName("page");
  for(var i=0;i<pages.length;i++) {
		pages[i].setAttribute("offset", i);
    curNode = pages.item(i);
		severity = 0;
		// Total Severity
		for(var j=0;j<curNode.childNodes.length;j++) {
			severity += parseInt(pages.item(i).childNodes.item(j).getAttribute("value")) ;
		}
		if(severity && severity < 1) {
			
			dump("title is " + curNode.getAttribute("title") + "\n");
			if(curNode.getAttribute("title").length) {
   			content = content + "<span title='" + curNode.getAttribute("url") +"'> " + curNode.getAttribute("title") + "</span>";			
			} else {
   			content = content + " " + curNode.getAttribute("url");
    	}
			content += "<a href='#page" + i + "' class='anchorlink'>>>> </a>";
			content += "<br/>";

			severity = Math.abs(severity);
			//arSeverity[severity][arSeverity[severity].length] = pages.item(i);
		}
  }
	keywords = xReview.getElementsByTagName("keyword");
  for(var i=0;i<keywords.length;i++) {
		keywords[i].setAttribute("offset", i);
    curNode = keywords.item(i);
		severity = 0;
		// Total Severity
		for(var j=0;j<curNode.childNodes.length;j++) {
			severity += parseInt(keywords.item(i).childNodes.item(j).getAttribute("value")) ;
			dump("upf sev " + severity + "\n");
		}
		if(severity && severity < 1) {
   		content = content + " " + curNode.getAttribute("id");
			content += "<a href='#keyword" + i + "' class='anchorlink'>>>> </a>";
		
    	content += "<br/>";

			severity = Math.abs(severity);
			//arSeverity[severity][arSeverity[severity].length] = pages.item(i);
		}
  }
	
	return content;
}

// Report title and owner
function urPopulateHeader(xReview) {
	var content = '';
	var projectNode = xReview.getElementsByTagName("project").item(0);
	var pname = projectNode.getAttribute("name");
	var powner =  projectNode.getAttribute("owner");
	content += "<h1> uzReview Report:" + pname + "</h1>";
	if(powner) content += "by " + powner + "<br/><br/><br/>";
	return content;
}

// For "Most Severe Problems" box
function urPopulateSevere(xReview) {
	var displayCount = 0;
	var content = '<ul>';
	var curHeur;
	for(var i=4;i>0;i--) {
		for(var j=0;j<arSeverity[i].length;j++) {
			curHeur = arSeverity[i][j];
			if(curHeur) {
			content += "<li class='severity" + curHeur.getAttribute("value")    + "'>" +  curHeur.getAttribute("value") + "::" + curHeur.getAttribute("id");
			content += "<a href='#heuristic" + curHeur.getAttribute("offset") + "' class='anchorlink'>>>></a>";
			content += "</li>";
			displayCount++;
			}
			if(displayCount > 5) break;
		}
		if(displayCount > 5) break;
	}
	return content + '</ul>';
}

// Body of page
function urPopulateContent(xReview) {
	var content = '';
	var curNode, curHeur;
	pages = xReview.getElementsByTagName("page");
  for(var i=0;i<pages.length;i++) {
		dump("popping " + i + "\n");
    curNode = pages.item(i);
		//content += "<a name='page" + i + "'>";
		if(curNode.hasAttribute("title")) {
	   	content +=  "<h3 id='page" + i + "' title='" +curNode.getAttribute("url") +"'>Page:" + curNode.getAttribute("title") + "</h3>";		
		} else {
    	content += "<h3 id='page" + i + "'>Page:" + curNode.getAttribute("url") + "</h3>";
		}
    content += "</a>";
		content +="<ul>";
		for(var j=0;j<curNode.childNodes.length;j++) {
			dump("j " + j + "\n");
			curHeur = curNode.childNodes.item(j);
			content += "<li id='heuristic" + curHeur.getAttribute("offset") + "' class='severity" + curHeur.getAttribute("value")    + "'>";
			content += curHeur.getAttribute("value") + "::" + curHeur.getAttribute("id") + "</li>";
			if(curHeur.childNodes.length) {
				content += "<ul><li>" + curHeur.firstChild.nodeValue + "</li></ul>";
			}
		}
		content += "</ul>"
  }
	//dump(content + "\n");
	keywords = xReview.getElementsByTagName("keyword");
  for(var l=0;l<keywords.length;l++) {
		dump("popping key " + l + "\n");
    curNode = keywords.item(l);
		content += "<a name='keyword" + l + "'>";
		if(curNode.hasAttribute("title")) {
	    content +=  "<h3 title='" +curNode.getAttribute("id") +"'>Keyword:" + curNode.getAttribute("id") + "</h3>";		
		} else {
    content += "<h3>Keyword:" + curNode.getAttribute("id") + "</h3>";
		}
    content += "</a><ul>";
		for(var m=0;m<curNode.childNodes.length;m++) {
			curHeur = curNode.childNodes.item(m);
			content += "<li class='severity" + curHeur.getAttribute("value")    + "'>" +  curHeur.getAttribute("value") + "::" + curHeur.getAttribute("id") + "</li>";
			if(curHeur.childNodes.length) {
				content += "<ul><li>" + curHeur.firstChild.nodeValue + "</li></ul>";
			}
		}
		content += "</ul>"
  }
	
	return content;
}

