
var lastLoc;
var curLoc ='null';
var curTitle='null';
var lastTitle='null';
// Flag to prevent mutliple load of same stuff
var inited = false;
// Flag indicating whether a review is currently active
var reviewStarted = false;
// Flag to track reviews on currently viewed page
var heuristicsLoggedOnPage = false;

// Global XML object
var heuristicsXML; // contains user review
var xHeuristics;   // contains heuristic list

var browserHandle = false;
var heuristicBaseUrl = "http://127.0.0.1/uzilla/"; // TODO DELETE

// Bookkeeping vars 
var uzInKeyword = false;  // Flag for keyword mdoe
var uzCurPageNode = false;  // Pointer to pre-existing page review
var uzCurKeywordNode = false; // Pointer to pre-existing keyword review
var uzKeywords = new Object(); // Collection of information about active keywords
var uzProjectName = false;

var heuristicXMLtemplate = '<?xml version="1.0"?>' + '<uzreviewdata>' + '<project name=""/>' + '</uzreviewdata>';

// Timing variables
var pageNetworkStart;
var pageNetworkEnd;
// Observer global
var urProgressListener;



function commitReview() {
	debugDump(">> uzReview:: Data file save begun\n");
	var commentFile;
  var serializer = new XMLSerializer;
  var du=new DirUtils(); 
  var output = serializer.serializeToString(xHeuristics);
  var dataPath = du.getChromeDir() + fileSeparator + 'uzreview' + fileSeparator + 'content' + fileSeparator + 'projects' + fileSeparator;
  var projectName = document.getElementById('heuristic_name').getAttribute("value");
  if(!projectName.length) {
		debugDump("--uzReview: CRITICAL FAILURE, project name is empty. Saving to untitled. \n");
		projectName = 'untitled';
  }
	var dataFile = new File(dataPath + projectName + ".xml");

	
	debugDump(">> uzReview: Saving to " + (dataPath + projectName + ".xml") + "\n");
  if(!dataFile.exists) dataFile.create();
  dataFile.open("w",777);
  dataFile.write(output);
  dataFile.close();
	debugDump(">> uzReview:: Data file saved\n");
	if(document.getElementById('edit-box').contentWindow.document.body.innerHTML.length) {
		commentFile = new File(dataPath + projectName + ".html");
		if(!commentFile.exists) dataFile.create();
		commentFile.open("w",777);
		commentFile.write( document.getElementById('edit-box').contentWindow.document.body.innerHTML);
		commentFile.close();
	}
}

function checkUnload() {
  if(reviewStarted) return confirm("Ready to close review?");
}

// Called when f8 
function uzreviewShowHide() {

    var uzreview_box = document.getElementById( 'uzreview-browser' );
   // var uzreview_browser = document.getElementById( 'left-content' );

    var uzreview_splitter = document.getElementById( 'uzreview-splitter' );

    if(uzreview_box.getAttribute('hidden') == 'true' || 
       uzreview_splitter.getAttribute( 'state' ) == 'collapsed' ) {
      //show the uzreview panel
      uzreview_splitter.removeAttribute( 'state' );
      uzreview_splitter.setAttribute( 'hidden', 'false' ); 
			uzreview_box.setAttribute('collapsed', 'false');
      uzreview_box.setAttribute( 'hidden', 'false' ); 
      debugDump('uzreview onload\n');
			document.getElementById("heuristicTopDeck").setAttribute("selectedIndex", 0);
    	uzPopulateSelector();
    // Start(); EDITOR STARTUP
    } else {

        //hide the uzreview panel
        uzreview_splitter.setAttribute( 'state', 'collapsed' );
        uzreview_splitter.setAttribute( 'hidden', 'true' );
    }
    //document.getElementById( 'content' ).focus();
  debugDump("Completed show hide\n");
}
